#!/usr/bin/python
# -*- coding: utf-8 -*-

import cups
import os
import pwd
import sys
import re
import tempfile
from datetime import date
import re


def mark ( jobID, title, copies, addrs, phone, place ):

	conn = cups.Connection()

	attr = conn.getJobAttributes( jobID )


	document = conn.getDocument( attr['printer-uri'], jobID, 1 )
	pattern = re.compile(r"/Count\s+(\d+)")
	pages=''
	content = open( document['file'], 'rb', 1).read()
	for match in pattern.finditer(content):
		pages = match.group(1)
        fonarik = tempfile.NamedTemporaryFile()
        skip = 56-addrs.count("\n")
        fonarik.write( "\n" * skip )
        fonarik.write( '       '+title.encode('utf-8')+"\n" )
        fonarik.write( '       '+u'Экземпляров '+repr(copies)+"\n" )
        fonarik.write( '       '+place.encode('utf-8')+"\n" )
        fonarik.write( '       '+addrs.encode('utf-8')+"\n" )
        dt =  pwd.getpwnam(attr['job-originating-user-name'])
        fonarik.write( '       '+u'Исполнитель '+(dt[4] if dt[4] else dt[0])+"\n" )
        fonarik.write( '       '+u'Тел. '+phone+"\n" )
        dt =  pwd.getpwuid(os.getuid())
        fonarik.write( '       '+u'Отпечатал '+(dt[4] if dt[4] else dt[0])+"\n" )
        fonarik.write( '       '+u'Всего страниц '+pages+"\n" )
        fonarik.write( '       '+date.today().strftime("%d.%m.%Y")+"\n" )
        fonarik.flush()


	queue = re.split( '/', attr['printer-uri'])[-1]
	alt_security_context = re.split( '-', attr['security-context-range'])[0]
	for i in range( int(copies) ) :
		copy = repr(i+1)
		newJob = conn.printFile( queue, document['file'], title+' '+u'Экз.№'+copy, {'alt-security-context-range': alt_security_context.encode('utf-8'),'alt-copy-number': copy.encode('utf-8'), 'alt-index': title.encode('utf-8'), 'job-hold-until': 'indefinite'})

		newJob = conn.printFile( queue, fonarik.name , u'Фонарик: '+title+u' Экз.№'+copy, {'job-hold-until': 'indefinite'})

        fonarik.close()
	os.remove( document['file'] )
	conn.cancelJob( jobID, True )

